package de.uni_marburg.powersort.benchmark;

import de.uni_marburg.powersort.data.CompetitionEnum;
import de.uni_marburg.powersort.data.DataEnum;
import de.uni_marburg.powersort.sort.SortEnum;
import org.openjdk.jmh.annotations.Benchmark;
import org.openjdk.jmh.annotations.Param;
import org.openjdk.jmh.annotations.Scope;
import org.openjdk.jmh.annotations.State;

/*
 * Benchmark state parameters
 *
 * Quote from JMH:
 * State objects naturally encapsulate the state on which benchmark is working on.
 */
@State(Scope.Benchmark)
public class JmhCompetition extends JmhBase {
    //@Param()
    @Param({
            // Top 4 Heavyweight by #comparisons
            "COMPETITION_207", "COMPETITION_214", "COMPETITION_213", "COMPETITION_236",
            // Top 4 Heavyweight by #merge-cost
            "COMPETITION_198","COMPETITION_199","COMPETITION_232","COMPETITION_231",
            // Top 4 Heavyweight by combined metric
            "COMPETITION_214","COMPETITION_218","COMPETITION_236","COMPETITION_213",
    })
    CompetitionEnum dataEnum;
    //@Param()
    @Param({"TIM_SORT", "FASTER_FINN_SORT", "IMPL_M_40"})
    SortEnum sortEnum;

    @Override
    DataEnum getDataEnum(){
        return dataEnum;
    }
    @Override
    SortEnum getSortEnum(){
        return sortEnum;
    }

    @Benchmark
    public void benchmark() {
        sortImpl.sort(workingCopy);
    }
}
