package de.uni_marburg.powersort.FinnSort;

import de.uni_marburg.powersort.JUnitUtil;
import de.uni_marburg.powersort.benchmark.NaturalOrder;
import org.junit.jupiter.api.RepeatedTest;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.params.ParameterizedTest;
import org.junit.jupiter.params.converter.ConvertWith;
import org.junit.jupiter.params.provider.CsvSource;

import java.util.Arrays;
import java.util.List;

import static org.junit.jupiter.api.Assertions.*;
import static org.mockito.ArgumentMatchers.*;
import static org.mockito.Mockito.*;

public class FasterFinnSortMockitoTest {
    @ParameterizedTest
    @CsvSource({
            "4|5|6|1|2|3",
            "100|10|11|1|2|3",
            "100|11|10|3|2|1",
            "24|25|26|27|28|21|22|23|18|19|20|4|5|6|7|8|9|10|11|12|13|14|15|16|17|3|1|2",
    })
    void foo(@ConvertWith(JUnitUtil.IntegerArrayConverter.class) Integer[] a) {
        printPowers(a);
    }

    void printPowers(Object[] a) {
        FasterFinnSort<Object> ffs = new FasterFinnSort<>(a, NaturalOrder.INSTANCE, null, 0, 0, a.length);
        FasterFinnSort<Object> spiedFfs = spy(ffs);

        // Don't extend short runs with `binarySort()`
        when(spiedFfs.minRunLength(anyInt())).thenReturn(0);

        // Capture calculated power values.
        final ResultCaptor<Integer> resultCaptor = new ResultCaptor<>();
        doAnswer(resultCaptor).when(spiedFfs).power(anyInt());


        sort(a, spiedFfs);


        List<Integer> calculatedPowers = resultCaptor.getAllValues();
        System.out.println(Arrays.toString(calculatedPowers.toArray()));
    }

    /**
     * Sorts the given array using FasterFinnSort.
     */
    void sort(Object[] a, FasterFinnSort<Object> ffs) {
        // Don't sort short array with `binarySort()`
        boolean forcePowersortShortArray = true;

        FasterFinnSortWrapper.sort(a, 0, a.length, NaturalOrder.INSTANCE, null, 0, 0, ffs, forcePowersortShortArray);
    }
}
